; count, example program for threadsp
; This program counts up A to Z with one thread and 0 to 9 with two other
; threads.
; This is a very trivial use for threadsp, but it demonstrates their use.

 nolist
 include "asm86.h"
 include "ti86asm.inc"
 list

 define STACK_SIZE 50

 org _asm_exec_ram
 define NEED_thread_cancel
 define NEED_thread_nice
 include "threads.asm"

 define mythread	program_end
 define mythread_stack	mythread+thread_t.sizeof+STACK_SIZE
 define mythread2	mythread_stack
 define mythread2_stack mythread2+thread_t.sizeof+STACK_SIZE
 define bytea		mythread2_stack
 define byteb		bytea+1
 define bytec		byteb+1

; main thread
main:
	ld	hl,mythread		; thread
	ld	de,mythread_code	; code
	ld	bc,mythread_stack	; stack
	call	thread_create
	
	ld	hl,mythread2		; thread
	ld	de,mythread2_code	; code
	ld	bc,mythread2_stack	; stack
	call	thread_create
	
	ld	hl,mythread
	ld	a,-20
	call	thread_nice		; thread_nice(&mythread, -20)
	
	ld	hl,mythread2
	ld	a,20
	call	thread_nice		; thread_nice(&mythread2, 20)
	
	ld	a,'A'
	ld	(bytea),a
_a
	ld	a,(bytea)
	ld	hl,0
		di
	ld	(_curRow),hl
	call	_putc
		ei
	inc	a
	cp	'Z'+1
	jr	nz,$+4
	ld	a,'A'
	ld	(bytea),a
	ld	b,0
_a1
;		push	bc
;	call	GET_KEY
;		pop	bc
;	xor	a
;	cp	K_1
;	call	z,thread_exit
;	ret	z		; return from program (this also kills mythread)
;	cp	K_2
;	jr	nz,_anot_2
;	ld	hl,mythread
;	call	thread_cancel	; cancel "mythread"
;_anot_2
	ld	a,(clock+1)
	cp	5
	ret	z
	djnz	_a1
	jr	_a

mythread_code:
	ld	a,'0'		; meat of thread
	ld	(byteb),a	;
_b
	ld	a,(byteb)
	ld	hl,1*256+0
		di
	ld	(_curRow),hl
	call	_putc
		ei
	inc	a
	cp	'9'+1
	jr	nz,$+4
	ld	a,'0'
	ld	(byteb),a
	ld	b,0
_b1
	ld	a,(clock+1)
	cp	3
	ret	z
	djnz	_b1
	jr	_b

mythread2_code:
	ld	a,'0'		; meat of thread
	ld	(bytec),a	;
_c
	ld	a,(bytec)
	ld	hl,2*256+0
		di
	ld	(_curRow),hl
	call	_putc
		ei
	inc	a
	cp	'9'+1
	jr	nz,$+4
	ld	a,'0'
	ld	(bytec),a
	ld	b,0
_c1
	ld	a,(clock+1)
	cp	1
	call	z,thread_exit
	djnz	_c1
	jr	_c

program_end:
 end
