/* count, example program for threadsp v0.5b
 * This program counts up A to Z with one thread and 0 to 9 with another thread.
 * This is a very trivial use for threads, but it demonstrates their use.
 */

#include <stdio.h>

#define STACK_SIZE 50

#define NEED_thread_cancel
#include "threads.h"

thread_t mythread;
char mythread_stack[STACK_SIZE];

void halt();
void *sp;

/* main thread
 * if 1 is pressed, kills thread1 and thread2
 * if 2 is pressed, kills thread2
 */
int main()
{
	char c = 'A';
	int count;
	void *mythread_code(void);
	
	thread_create(&mythread, mythread_code, mythread_stack);
	while (1) {
		putchar(c);
		if (++c > 'Z')
			c = 'A';
		for (count = 10*2; count; --count) {
			switch (getchar()) {
			case '1':
				return 0;
			case '2':
				thread_cancel(&mythread);
			}
		}
	}
}

void *mythread_code() {
	char c = '0';
	int count;
	
	while (1) {
		putchar(c);
		if (++c > '9')
			c = '0';
		for (count = 26*2; count; --count)
			;
	}
}
